'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ（ｽｶｲﾗｲﾝ法）
Imports System.Drawing

Public Class FEM2NLCal3
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(224, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "２次元構造解析計算の実行"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(280, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(144, 192)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(136, 24)
        Me.PictureBox1.TabIndex = 3
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(144, 136)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(224, 24)
        Me.PictureBox2.TabIndex = 4
        Me.PictureBox2.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'FEM2Cal3
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.ProgressBar1, Me.PictureBox2, Me.PictureBox1, Me.Label3, Me.Label2, Me.Label1})
        Me.Name = "FEM2Cal3"
        Me.Text = "FEM2Cal3"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim SwK As IO.StreamWriter  '結果出力用

    Dim NumEff As Integer       'FEM行列（右上三角）のｲﾝﾃﾞｯｸｽ数

    Dim CInc As Single          '最適化計算の増倍率（通常2～3）
    Dim CRed As Single          '最適化計算の低減率（通常0.5～0.1）
    Dim EpsMax As Single        '最大の相当歪み
    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置

    Dim Idiag() As Integer      '元のFEM行列対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim KDispMax(3) As Integer  '最大変位の節点番号
    Dim KStMax(9) As Integer    '最大応力の節点番号
    Dim Nw() As Integer         '各節点の共通要素数

    Dim B(,) As Double          'Bﾏﾄﾘｯｸｽ
    Dim D(,) As Double          'Dﾏﾄﾘｯｸｽ
    Dim Db(,) As Double         'DBﾏﾄﾘｯｸｽ
    Dim DispMax(3) As Single    '最大変位
    Dim Dratio(2) As Single     '最適化計算の変数変化ΔＸの比率（＝ΔＸ／Ｘ）
    Dim Ds(8), Dt(8) As Double  '形状関数のs偏微分、t偏微分
    Dim Dx(8), Dy(8) As Double  '形状関数のx偏微分、y偏微分
    Dim Ek(,) As Double         '要素計算の２次配列
    Dim EpsG(6) As Double       '積分点の歪み
    Dim EpsX(2) As Single       '最適化計算の変数Ｘの最小変化量（絶対値）
    Dim Eu() As Double          '節点変位
    Dim Eyb(,) As Single        '全要素の積分点のﾔﾝｸﾞ率
    Dim Sgaus(,) As Double      '要素計算のｶﾞｳｽ点応力
    Dim Shape(8) As Double       '要素の形状関数
    Dim Spoint(,) As Double     '要素計算の節点応力
    Dim StMax(9) As Single      '最大応力
    Dim TempE(8) As Double      '要素節点の温度
    Dim TempIE(8) As Double     '要素節点の初期温度
    Dim TempG(9) As Double      'ｶﾞｳｽ点の温度
    Dim TempIG(9) As Double     'ｶﾞｳｽ点の初期温度
    Dim Tf() As Double          'FEM計算の右辺ﾍﾞｸﾄﾙ
    Dim Tfx() As Single         '初期変位
    Dim Tk() As Double          'FEM行列の1次元保存配列
    Dim Tp(,) As Double         '節点応力累積値
    Dim XEI(), YEI() As Single  '要素節点の初期座標（大変形の場合）
    Dim XG(9), YG(9) As Double  'ｶﾞｳｽ点の座標
    Dim XGI(), YGI() As Single  'ｶﾞｳｽ点の初期座標（大変形の場合）
    Dim Xvar(2) As Single       '最適化計算の各変数Ｘ（要素内座標ξ、η）

    Private Sub BForceCalc()
        '拘束節点の反力計算
        Dim aa$
        Dim i, ib, id, ie, ii, ip, j, jj, k, kb As Integer
        Dim b1 As Single
        Dim h, rnu As Double
        Dim buf(Ndim), tfb(Nvar), zbuf(Nvar) As Single

        Select Case Ntype
            Case 3
                aa$ = "＜節点番号、Ｗ、Ｍθx、Ｍθy＞"
            Case 4
                aa$ = "＜節点番号、Ｆr、Ｆz＞"
            Case Else
                aa$ = "＜節点番号、Ｆx、Ｆy＞"
        End Select
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 拘束節点の反力 ＊＊")
        SwK.WriteLine(aa$)

        kb = 0
        For ib = 1 To Nbound
            For i = 1 To Ndim
                buf(i) = 0
            Next i
            ii = Nrest(ib)
            For ie = 1 To Nelem
                k = 0
                For j = 1 To 8
                    If NNelem(ie, j) = ii Then
                        k = j
                        Exit For
                    End If
                Next j
                If k > 0 Then
                    jj = 0
                    For j = 1 To 8
                        ip = NNelem(ie, j)
                        i = Ndim * (Kcomp(ip) - 1)
                        For id = 1 To Ndim
                            jj = jj + 1
                            zbuf(jj) = Tf(i + id)
                        Next id
                    Next j
                    Call ElemMatrix3(ie, kb, h, rnu, zbuf)      '要素ﾏﾄﾘｯｸｽの計算
                    For i = 2 To Nvar
                        For j = 1 To i - 1
                            Ek(i, j) = Ek(j, i)
                        Next j
                    Next i
                    For i = 1 To Nvar
                        b1 = 0
                        For j = 1 To Nvar
                            b1 = b1 + Ek(i, j) * zbuf(j)
                        Next j
                        tfb(i) = b1
                    Next i
                    j = Ndim * (k - 1)
                    For i = 1 To Ndim
                        j = j + 1
                        buf(i) = buf(i) + tfb(j)
                    Next
                End If
            Next ie
            aa$ = Str(ii)
            For i = 1 To Ndim
                If Jdirect(ib, i) = 0 Then
                    buf(i) = 0
                End If
                id = Jdirect(ib, i)
                aa$ = aa$ + ",  " + Str(buf(i))
            Next i
            SwK.WriteLine(aa$)
        Next ib

        If Ntype <> 3 And Nslope > 0 Then
            Dim b2, b3, cosb, sinb As Single
            b3 = Pai / 180
            aa$ = "＜節点番号、傾斜に垂直の力＞"
            SwK.WriteLine("-----------------------------------------------")
            SwK.WriteLine("＊＊ 傾斜拘束節点の反力 ＊＊")
            SwK.WriteLine(aa$)
            For ib = 1 To Nslope
                For i = 1 To Ndim
                    buf(i) = 0
                Next i
                ii = Nsrest(ib)
                For ie = 1 To Nelem
                    k = 0
                    For j = 1 To 8
                        If NNelem(ie, j) = ii Then
                            k = j
                            Exit For
                        End If
                    Next j
                    If k > 0 Then
                        jj = 0
                        For j = 1 To 8
                            ip = NNelem(ie, j)
                            i = Ndim * (Kcomp(ip) - 1)
                            For id = 1 To Ndim
                                jj = jj + 1
                                zbuf(jj) = Tf(i + id)
                            Next id
                        Next j
                        Call ElemMatrix3(ie, kb, h, rnu, zbuf)      '要素ﾏﾄﾘｯｸｽの計算
                        For i = 2 To Nvar
                            For j = 1 To i - 1
                                Ek(i, j) = Ek(j, i)
                            Next j
                        Next i
                        For i = 1 To Nvar
                            b1 = 0
                            For j = 1 To Nvar
                                b1 = b1 + Ek(i, j) * zbuf(j)
                            Next j
                            tfb(i) = b1
                        Next i
                        j = Ndim * (k - 1)
                        For i = 1 To Ndim
                            j = j + 1
                            buf(i) = buf(i) + tfb(j)
                        Next
                    End If
                Next ie
                b2 = SAngle(ib) * b3
                cosb = Math.Cos(b2)
                sinb = Math.Sin(b2)
                zbuf(1) = cosb * buf(1) + sinb * buf(2)
                zbuf(2) = cosb * buf(2) - sinb * buf(1)
                aa$ = Str(ii) + ",  " + Str(zbuf(2))
                SwK.WriteLine(aa$)
            Next ib

        End If

    End Sub

    Private Sub BMatrix(ByVal kg As Integer)
        '変位を歪に変換するﾏﾄﾘｯｸｽの計算
        'kg･･･ｶﾞｳｽ点番号
        Dim i, ii, isb, j As Integer
        For isb = 1 To Nstress
            For i = 1 To Nvar
                B(isb, i) = 0
            Next i
        Next isb
        j = 0
        For ii = 1 To 8
            i = j + 1
            Select Case Ntype
                Case Is <= 2
                    j = i + 1
                    B(1, i) = Dx(ii) : B(2, j) = Dy(ii)
                    B(3, i) = Dy(ii) : B(3, j) = Dx(ii)
                Case 3
                    B(4, i) = Dy(ii) : B(5, i) = Dx(ii)
                    i = i + 1 : j = i + 1
                    B(1, i) = -Dy(ii) : B(2, j) = -Dx(ii)
                    B(3, i) = -Dx(ii) : B(3, j) = -Dy(ii)
                    B(4, i) = -Shape(ii)
                    B(5, j) = -Shape(ii)
                Case 4
                    j = i + 1
                    B(1, i) = Dx(ii) : B(2, j) = Dy(ii)
                    B(3, i) = Shape(ii) / XG(kg)
                    B(4, i) = Dy(ii) : B(4, j) = Dx(ii)
            End Select
        Next ii

    End Sub

    Private Sub CalFunc(ByRef sf As Single, ByVal s As Single, _
    ByVal t As Single, ByVal xc As Single, ByVal yc As Single)
        '任意の関数式を定義して、その関数値を計算する。
        'sf･･･関数値
        's,t･･･要素の局所座標
        'xc,yc･･･現在位置の座標
        Dim i As Integer
        Dim b1, b2, xbb, ybb As Single
        Call ShapeFuncS(s, t)   '形状関数の計算
        xbb = 0
        ybb = 0
        For i = 1 To 8
            b1 = XE(i)
            b2 = YE(i)
            xbb = xbb + Shape(i) * XE(i)
            ybb = ybb + Shape(i) * YE(i)
        Next i
        b1 = xbb - xc
        b2 = ybb - yc
        sf = b1 * b1 + b2 * b2

    End Sub

    Private Sub CoeffMatrix(ByVal ie As Integer, ByVal istage As Integer, _
        ByVal h As Double, ByRef rnu As Double, ByVal ud As Double)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･計算区分（-1:初期応力、0:主計算、1:ｶﾞｳｽ点応力）
        'h･･･要素厚さ
        'rnu･･･ﾎﾟｱｿﾝ比
        'ud･･･材料の比重量
        Dim i, ib, id, ig, ii, isb, isb2, j, j1, j2, jg, k, kg, kkg, kx As Integer
        Dim e As Single
        Dim b1, b2, b3, da, dj, omega2, rmass As Double
        Dim s, sx, sy, t, txy, txz, tyz As Double
        Dim z As Single
        Dim gbuf(2) As Double

        If KindGrav > 0 Then
            Select Case Ntype
                Case 3
                    j1 = 1 : j2 = 1
                    gbuf(1) = GravMulti(1)
                Case 4
                    j1 = 2 : j2 = 2
                    gbuf(2) = GravMulti(1)
                Case Else
                    j1 = 1 : j2 = 2
                    gbuf(1) = GravMulti(1)
                    gbuf(2) = GravMulti(2)
            End Select
        End If
        If Ntype = 4 And KindRevF > 0 Then
            rmass = ud / AccGrav
            b1 = Dpai * RevPS
            omega2 = b1 * b1
        End If
        If Ntype < 3 Then
            isb2 = 2
        Else
            isb2 = 3
        End If

        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                If istage > 0 And KindDPL > 0 Then
                    Call GausInit(kg)   'ｶﾞｳｽ点初期座標の計算
                End If
                da = dj * WeightG(ig) * WeightG(jg)
                Select Case Ntype
                    Case Is < 3
                        da = da * h
                    Case 4
                        da = da * Dpai * XG(kg)
                End Select
                If istage = 0 Then
                    If KindGrav > 0 Then
                        b2 = ud * da
                        If Ntype = 3 Then
                            b2 = b2 * h
                        End If
                        For ii = 1 To 8
                            i = NNelem(ie, ii)
                            k = Ndim * (Kcomp(i) - 1)
                            b1 = b2 * Shape(ii)
                            For j = j1 To j2
                                kx = k + j
                                Tf(kx) = Tf(kx) + b1 * gbuf(j)
                            Next j
                        Next ii
                    End If
                    If Ntype = 4 And KindRevF > 0 Then
                        For ii = 1 To 8
                            i = NNelem(ie, ii)
                            k = Ndim * (Kcomp(i) - 1) + 1
                            b1 = rmass * Shape(ii) * da
                            Tf(k) = Tf(k) + b1 * omega2 * XG(kg)
                        Next ii
                    End If
                End If

                Call BMatrix(kg)
                For i = 1 To Nstress
                    For j = 1 To Nstress
                        D(i, j) = 0
                    Next j
                Next i
                e = Eyb(ie, kg)
                Call DMatrix(ie, e)

                If istage < 0 Then
                    k = NumMat(ie)
                    b1 = Alpha(k)
                    If KindTemp = 0 Then
                        b2 = b1 * (TempG(kg) - TempIG(kg))
                    Else
                        b2 = b1 * (Temp(k) - TempInit(k))
                    End If
                    b3 = D(0, 0) * b2 * da
                    For i = 1 To 8
                        k = Ndim * (i - 1)
                        j1 = NPrefer(k + 1)
                        j2 = NPrefer(k + 2)
                        Tf(j1) = Tf(j1) + Dx(i) * b3
                        Tf(j2) = Tf(j2) + Dy(i) * b3
                        If Ntype = 4 Then
                            ib = 2 * i - 1
                            Tf(j1) = Tf(j1) + B(3, ib) * b3
                        End If
                    Next i
                Else
                    For isb = 1 To Nstress
                        For i = 1 To Nvar
                            Db(isb, i) = 0
                            For j = 1 To Nstress
                                Db(isb, i) = Db(isb, i) + D(isb, j) * B(j, i)
                            Next j
                        Next i
                        If istage > 0 Then
                            Sgaus(kg, isb) = 0 : kkg = 0
                            For ii = 1 To 8
                                For id = 1 To Ndim
                                    kkg = kkg + 1
                                    Sgaus(kg, isb) = Sgaus(kg, isb) + Db(isb, kkg) * Eu(kkg)
                                Next id
                            Next ii
                        End If
                    Next isb

                    If istage = 0 Then
                        For i = 1 To Nvar
                            For j = i To Nvar
                                For isb = 1 To Nstress
                                    Ek(i, j) = Ek(i, j) + B(isb, i) * Db(isb, j) * da
                                Next isb
                            Next j
                        Next i
                    Else
                        If KindHSt > 0 Then
                            k = NumMat(ie)
                            b1 = Alpha(k)
                            If KindTemp = 0 Then
                                b2 = b1 * (TempG(kg) - TempIG(kg))
                            Else
                                b2 = b1 * (Temp(k) - TempInit(k))
                            End If
                            b3 = D(0, 0) * b2
                            For isb = 1 To isb2
                                Sgaus(kg, isb) = Sgaus(kg, isb) - b3
                            Next isb
                        End If

                        If Ntype = 2 Then
                            Sgaus(kg, Nstress + 1) = rnu * (Sgaus(kg, 1) + Sgaus(kg, 2))
                        ElseIf Ntype = 3 And KindHSt = 0 Then
                            'z = h * h / 6
                            z = -h * h / 6
                            sy = Sgaus(kg, 1) / z : sx = Sgaus(kg, 2) / z
                            txy = Sgaus(kg, 3) / z
                            tyz = Sgaus(kg, 4) * 1.5 / h : txz = Sgaus(kg, 5) * 1.5 / h
                            Sgaus(kg, 1) = sx : Sgaus(kg, 2) = sy : Sgaus(kg, 3) = txy
                            Sgaus(kg, 4) = txz : Sgaus(kg, 5) = tyz
                        End If
                    End If
                End If
            Next jg
        Next ig

    End Sub

    Private Sub CoeffMatrix2(ByVal ie As Integer, ByVal h As Double, ByRef rnu As Double)
        '要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'h･･･要素厚さ
        'rnu･･･ﾎﾟｱｿﾝ比
        Dim i, ig, isb, j, jg, kg As Integer
        Dim da, dj, e, s, t As Double

        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                da = dj * WeightG(ig) * WeightG(jg)
                Select Case Ntype
                    Case Is < 3
                        da = da * h
                    Case 4
                        da = da * Dpai * XG(kg)
                End Select

                Call BMatrix(kg)
                e = Eyb(ie, kg)
                Call DMatrix(ie, e)

                For isb = 1 To Nstress
                    For i = 1 To Nvar
                        Db(isb, i) = 0
                        For j = 1 To Nstress
                            Db(isb, i) = Db(isb, i) + D(isb, j) * B(j, i)
                        Next j
                    Next i
                Next isb

                For i = 1 To Nvar
                    For j = i To Nvar
                        For isb = 1 To Nstress
                            Ek(i, j) = Ek(i, j) + B(isb, i) * Db(isb, j) * da
                        Next isb
                    Next j
                Next i
            Next jg
        Next ig

    End Sub

    Private Sub CosCalc2(ByVal aval1() As Single, ByVal aval2() As Single, _
    ByRef acos() As Single)
        '2点間の方向余弦の計算
        'aval1(),aval2()・・・2点のXY座標
        'acos()・・・XY座標への方向余弦
        Dim j As Integer
        Dim b1 As Single
        Dim buf(2) As Single

        For j = 1 To 2
            buf(j) = aval2(j) - aval1(j)
        Next j
        b1 = 0
        For j = 1 To 2
            b1 = b1 + buf(j) * buf(j)
        Next j
        b1 = Math.Sqrt(b1)
        For j = 1 To 2
            acos(j) = buf(j) / b1
        Next j

    End Sub

    Private Sub Debug1(ByVal mh As Integer, ByVal nx As Integer)
        '全体ﾏﾄﾘｯｸｽを出力して停止
        '非0要素のみ出力
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, fxx$
        Dim i, ic, ii, j, j2, kx As Integer
        Dim z1 As Single
        ii = FreeFile()
        fxx$ = DirOpen$ + "\FEM2NLdebug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜＜全体マトリックスデータ＞＞"
        WriteLine(ii, aa$)
        For i = 1 To nx
            aa$ = "行" + Str$(i)
            WriteLine(ii, aa$)
            j2 = i + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            ic = 0
            For j = i To j2
                kx = Idiag(j) - (j - i)
                z1 = Tk(kx)
                If z1 <> 0 Then
                    If ic = 0 Then
                        aa$ = Str$(j) + ",  " + Str$(z1)
                    Else
                        aa$ = aa$ + ",    " + Str$(j) + ",  " + Str$(z1)
                    End If
                    If ic = 4 Then
                        PrintLine(ii, aa$)
                        ic = 0
                    Else
                        ic = ic + 1
                    End If
                End If
            Next j
            If ic > 0 Then
                PrintLine(ii, aa$)
            End If
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug2()
        '要素のＫﾏﾄﾘｯｸｽ（２次元構造）を出力して停止
        Dim aa$, fxx$
        Dim i, ii, j As Integer
        Dim z1 As Single

        fxx$ = DirOpen$ + "\FEM2NLDebug2.dat"
        ii = FreeFile()
        FileOpen(ii, fxx$, OpenMode.Output)
        For i = 1 To 8
            WriteLine(ii, "行番号", i)
            z1 = Ek(i, 1)
            aa$ = Str(z1)
            For j = 2 To 8
                z1 = Ek(i, j)
                aa$ = aa$ + ",  " + Str(z1)
            Next j
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug5()
        '右辺ﾍﾞｸﾄﾙを出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\FEM2NLDebug5.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "右辺ベクトル"
        WriteLine(ii, aa$)
        WriteLine(ii, "行番号、右辺値")
        For i = 1 To Nall
            aa$ = Str$(i)
            aa$ = aa$ + ",  " + Str$(Tf(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub DMatrix(ByVal ie As Integer, ByVal e As Single)
        '弾性ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'e･･･ﾔﾝｸﾞ率
        Dim i, j, kp As Integer
        Dim h, rnu, ud As Single
        Dim b1, b2 As Double

        For i = 1 To Nstress
            For j = 1 To Nstress
                D(i, j) = 0
            Next j
        Next i
        kp = NumMat(ie)
        rnu = DataMat(kp, 2)
        If Ntype < 4 Then
            h = DataMat(kp, 3)
            ud = DataMat(kp, 4)
        Else
            ud = DataMat(kp, 3)
        End If
        Select Case Ntype   '歪から応力を換算するﾏﾄﾘｯｸｽ成分の計算
            Case 1
                D(0, 0) = e / (1 - rnu)
                b1 = e / (1 - rnu * rnu)
                D(1, 1) = b1 : D(2, 2) = b1
                D(1, 2) = b1 * rnu : D(2, 1) = b1 * rnu
                D(3, 3) = b1 * (1 - rnu) / 2
            Case 2
                D(0, 0) = e / (1 - 2 * rnu)
                b1 = e * (1 - rnu) / ((1 + rnu) * (1 - 2 * rnu))
                D(1, 1) = b1 : D(2, 2) = b1
                D(1, 2) = b1 * rnu / (1 - rnu) : D(2, 1) = D(1, 2)
                D(3, 3) = b1 * (1 - 2 * rnu) / (2 * (1 - rnu))
            Case 3
                D(1, 1) = e * h ^ 3 / (12 * (1 - rnu * rnu))
                D(1, 2) = rnu * D(1, 1) : D(2, 1) = D(1, 2)
                D(3, 3) = (1 - rnu) * D(1, 1) / 2
                D(4, 4) = e * h / (2.4 * (1 + rnu))
                D(2, 2) = D(1, 1) : D(5, 5) = D(4, 4)
            Case 4
                D(0, 0) = e / (1 - 2 * rnu)
                b1 = e * (1 - rnu) / ((1 + rnu) * (1 - 2 * rnu))
                b2 = b1 * rnu / (1 - rnu)
                D(1, 1) = b1 : D(2, 2) = b1 : D(3, 3) = b1
                D(1, 2) = b2 : D(2, 1) = b2
                D(1, 3) = b2 : D(3, 1) = b2
                D(2, 3) = b2 : D(3, 2) = b2
                D(4, 4) = b1 * (1 - 2 * rnu) / (2 * (1 - rnu))
        End Select

    End Sub

    Private Sub EJoungCalc(ByVal ie As Integer, ByRef ej As Single)
        'ﾔﾝｸﾞ率の計算
        'ie･･･要素番号
        'ej･･･ﾔﾝｸﾞ率
        Dim kmat As Integer
        Dim b1, b2, b3, epsb, epsz, rnu As Double

        kmat = NumMat(ie)
        rnu = DataMat(kmat, 2)

        '相当歪みepsbの計算
        Select Case Ntype
            Case 1  '平面応力
                b1 = 2 * (EpsG(1) ^ 2 - EpsG(1) * EpsG(2) + EpsG(2) ^ 2)
                b2 = 1.5 * EpsG(3) ^ 2
            Case 2
                epsz = rnu * (EpsG(1) + EpsG(2))
                b1 = (EpsG(1) - EpsG(2)) ^ 2 + (EpsG(1) - epsz) ^ 2 + (EpsG(2) - epsz) ^ 2
                b2 = 1.5 * EpsG(3) ^ 2
            Case 3
                b1 = 2 * (EpsG(1) ^ 2 - EpsG(1) * EpsG(2) + EpsG(2) ^ 2)
                b2 = 1.5 * (EpsG(3) ^ 2 + EpsG(4) ^ 2 + EpsG(5) ^ 2)
            Case 4
                b1 = (EpsG(1) - EpsG(2)) ^ 2 + (EpsG(2) - EpsG(3)) ^ 2 + (EpsG(3) - EpsG(1)) ^ 2
                b2 = 1.5 * EpsG(4) ^ 2
        End Select
        b3 = (b1 + b2) * 2 / 9
        epsb = Math.Sqrt(b3)
        If epsb > EpsMax Then
            EpsMax = epsb
        End If

        Call StateCalc(kmat, ej, epsb)   '物性状態の計算

    End Sub

    Private Sub ElemFA(ByRef ke As Integer, ByVal xb As Single, ByVal yb As Single)
        '該当要素の検出
        'ke･･･該当要素
        'xb,yb･･･座標位置
        Dim i, ic, j, jj, k, k1, k2 As Integer
        Dim area, eps, x0, x1, x2, y0, y1, y2 As Single
        Dim xx(3), yy(3) As Single

        ke = 0
        For i = 1 To Nelem
            x0 = 0
            y0 = 0
            For k = 1 To 8
                XE(k) = X(NNelem(i, k))
                YE(k) = Y(NNelem(i, k))
                x0 = x0 + XE(k)
                y0 = y0 + YE(k)
            Next k
            xx(3) = x0 / 8
            yy(3) = y0 / 8
            For k = 1 To 8
                Select Case k
                    Case 1
                        k1 = 1 : k2 = 2
                    Case 2
                        k1 = 2 : k2 = 3
                    Case 3
                        k1 = 3 : k2 = 4
                    Case 4
                        k1 = 4 : k2 = 5
                    Case 5
                        k1 = 5 : k2 = 6
                    Case 6
                        k1 = 6 : k2 = 7
                    Case 7
                        k1 = 7 : k2 = 8
                    Case 8
                        k1 = 8 : k2 = 1
                End Select
                xx(1) = XE(k1) : yy(1) = YE(k1)
                xx(2) = XE(k2) : yy(2) = YE(k2)
                ic = 0
                For j = 1 To 3
                    x1 = xx(j)
                    y1 = yy(j)
                    jj = j + 1
                    If jj > 3 Then
                        jj = 1
                    End If
                    x2 = xx(jj)
                    y2 = yy(jj)
                    Call AreaCalc(area, x1, y1, x2, y2, xb, yb)
                    '三角形の符号付き面積算出（最初の2点に対して左側は正、右側は負）
                    If area < 0 Then
                        ic = -1
                        Exit For
                    End If
                Next j
                If ic = 0 Then
                    ke = i
                    Exit Sub
                End If
            Next k
        Next i

        If ke = 0 Then
            For i = 1 To Nelem
                x0 = 0
                y0 = 0
                For k = 1 To 8
                    XE(k) = X(NNelem(i, k))
                    YE(k) = Y(NNelem(i, k))
                    x0 = x0 + XE(k)
                    y0 = y0 + YE(k)
                Next k
                x0 = x0 / 8
                y0 = y0 / 8
                Call AreaCalc(area, x1, y1, x2, y2, x0, y0) '三角形の符号付き面積算出
                eps = 0.1 * area
                xx(3) = x0
                yy(3) = y0
                ic = 0
                For k = 1 To 8
                    Select Case k
                        Case 1
                            k2 = 1 : k2 = 2
                        Case 2
                            k1 = 2 : k2 = 3
                        Case 3
                            k1 = 3 : k2 = 4
                        Case 4
                            k1 = 4 : k2 = 5
                        Case 5
                            k1 = 5 : k2 = 6
                        Case 6
                            k1 = 6 : k2 = 7
                        Case 7
                            k1 = 7 : k2 = 8
                        Case 8
                            k1 = 8 : k2 = 1
                    End Select
                    xx(1) = XE(k1) : yy(1) = YE(k1)
                    xx(2) = XE(k2) : yy(2) = YE(k2)
                    For j = 1 To 3
                        x1 = xx(j)
                        y1 = yy(j)
                        jj = jj + 1
                        If jj > 3 Then
                            jj = 1
                        End If
                        x2 = xx(jj)
                        y2 = yy(jj)
                        Call AreaCalc(area, x1, y1, x2, y2, xb, yb)
                        '三角形の符号付き面積算出（最初の2点に対して左側は正、右側は負）
                        If area < -eps Then
                            ic = -1
                            Exit For
                        End If
                    Next j
                    If ic = 0 Then
                        ke = i
                        Exit Sub
                    End If
                Next k
            Next i
        End If

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByVal istage As Integer, _
        ByRef kb As Integer, ByRef h As Double, ByRef rnu As Double, ByRef ud As Double)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･計算区分（-1:初期応力、0:主計算、1:ｶﾞｳｽ点応力）
        'kb･･･材料番号
        'h･･･要素厚さ
        'rnu･･･ﾎﾟｱｿﾝ比
        'ud･･･材料の比重量
        Dim i, id, ii, j, k, kp As Integer

        kp = NumMat(ie)
        If kp <> kb Then
            kb = kp
            rnu = DataMat(kp, 2)
            If Ntype < 4 Then
                h = DataMat(kp, 3)
                ud = DataMat(kp, 4)
            Else
                ud = DataMat(kp, 3)
            End If
        End If

        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i)
            YE(ii) = Y(i)
            If istage > 0 And KindDPL > 0 Then
                XEI(ii) = X(i)
                YEI(ii) = Y(i)
            End If
            If KindHSt > 0 And KindTemp = 0 Then
                TempE(ii) = Temp(i)
                TempIE(ii) = TempInit(i)
            End If
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1
                k = k + 1
                NPrefer(j) = k
                If KindDPL > 0 Then
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + Tfx(k)
                        Case 2
                            YE(ii) = YE(ii) + Tfx(k)
                    End Select
                End If
            Next id
        Next ii

        Call CoeffMatrix(ie, istage, h, rnu, ud)  '各要素の係数ﾏﾄﾘｯｸｽの計算

    End Sub

    Private Sub ElemMatrix2(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算2
        'ie･･･要素番号
        Dim i, id, ii, j, k As Integer

        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i)
            YE(ii) = Y(i)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1
                k = k + 1
                NPrefer(j) = k
                If KindDPL > 0 Then
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + Tfx(k)
                        Case 2
                            YE(ii) = YE(ii) + Tfx(k)
                    End Select
                End If
            Next id
        Next ii

        Call EpsElem(ie)   '各要素の歪み計算

    End Sub

    Private Sub ElemMatrix3(ByVal ie As Integer, ByRef kb As Integer, _
    ByRef h As Double, ByRef rnu As Double, ByVal zbuf() As Single)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kb･･･材料番号
        'h･･･要素厚さ
        'rnu･･･ﾎﾟｱｿﾝ比
        'zbuf()･･･節点変位
        Dim i, id, ii, j, kp As Integer

        kp = NumMat(ie)
        If kp <> kb Then
            For i = 1 To Nstress
                For j = 1 To Nstress
                    D(i, j) = 0
                Next j
            Next i
            kb = kp
            rnu = DataMat(kp, 2)
            If Ntype < 4 Then
                h = DataMat(kp, 3)
            End If
        End If

        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i)
            YE(ii) = Y(i)
            For id = 1 To Ndim
                j = j + 1
                If KindDPL > 0 Then
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + zbuf(j)
                        Case 2
                            YE(ii) = YE(ii) + zbuf(j)
                    End Select
                End If
            Next id
        Next ii

        Call CoeffMatrix2(ie, h, rnu)  '各要素の係数ﾏﾄﾘｯｸｽの計算

    End Sub

    Private Sub ElemMatrixPL(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算(板の曲げ)
        'ie･･･要素番号
        Dim i, id, ii, istage, j, k, kb, kg As Integer
        Dim ej, g, h, rnu, ud As Double

        For i = 1 To Nvar
            For j = i To Nvar
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To 8
            i = NNelem(ie, ii)
            XE(ii) = X(i)
            YE(ii) = Y(i)
            k = Ndim * (Kcomp(i) - 1)
            For id = 1 To Ndim
                j = j + 1
                k = k + 1
                NPrefer(j) = k
                If KindDPL > 0 Then
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + Tfx(k)
                        Case 2
                            YE(ii) = YE(ii) + Tfx(k)
                    End Select
                End If
            Next id
        Next ii


        kg = 9  'ｶﾞｳｽ点総数

        istage = 1
        Call ElemMatrix(ie, istage, kb, h, rnu, ud)      '要素ﾏﾄﾘｯｸｽの計算

        'ｶﾞｳｽ点毎に相当歪みを算出し、Eybを変更する
        kb = NumMat(ie)
        rnu = DataMat(kb, 2)
        For j = 1 To kg
            ej = Eyb(ie, j)
            g = 0.5 * ej / (1 + rnu)
            EpsG(1) = Sgaus(j, 1) / ej
            EpsG(2) = Sgaus(j, 2) / ej
            EpsG(3) = Sgaus(j, 3) / g
            EpsG(4) = Sgaus(j, 4) / g
            EpsG(5) = Sgaus(j, 5) / g

            Call EJoungCalc(ie, ej) 'ﾔﾝｸﾞ率の計算
            Eyb(ie, j) = ej
        Next j

    End Sub

    Private Sub EpsElem(ByVal ie As Integer)
        '各要素の歪み計算
        'ie･･･要素番号
        Dim i, id, ig, ii, jg, kg, kkg As Integer
        Dim ej As Single
        Dim b1, dj, s, t As Double

        kg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                kg = kg + 1
                Call ShapeFunc(s, t)            '形状関数の計算
                Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                Call BMatrix(kg)
                For i = 1 To Nstress
                    b1 = 0
                    kkg = 0
                    For ii = 1 To 8
                        For id = 1 To Ndim
                            kkg = kkg + 1
                            b1 = b1 + B(i, kkg) * Eu(kkg)
                        Next id
                    Next ii
                    EpsG(i) = b1
                Next i
                Call EJoungCalc(ie, ej) 'ﾔﾝｸﾞ率の計算
                Eyb(ie, kg) = ej
            Next jg
        Next ig

    End Sub

    Private Sub FALoadSet()
        '座標位置荷重の設定
        Dim aa$
        Dim i, id, j, k, kb, ke, kk As Integer
        Dim s, s0, sfm, t, xb, yb As Single

        CInc = 3
        CRed = 0.2
        For i = 1 To NforceA
            xb = XFA(i)
            yb = YFA(i)
            Call ElemFA(ke, xb, yb) '該当要素の検出
            If ke = 0 Then
                aa$ = "座標位置荷重の座標が構造外にあります！"
                MsgBox(aa$, 0, "データエラー")
                Me.Close()
            End If
            For j = 1 To 8
                XE(j) = X(NNelem(ke, j))
                YE(j) = Y(NNelem(ke, j))
            Next j
            s = 0.2 : t = 0.2
            Call KHSolver(k, 100, s0, sfm, s, t, xb, yb)
            'KH法による最適化ｿﾙﾊﾞｰ

            Call ShapeFuncS(s, t)   '形状関数の計算

            For j = 1 To 8
                kk = NNelem(ke, j)
                kb = Ndim * (Kcomp(kk) - 1)
                For id = 1 To Ndim
                    k = kb + id
                    Tf(k) = Tf(k) + Shape(j) * ForceA(i, id)
                Next id
            Next j
        Next i

    End Sub

    Private Sub FLoadSet()
        '節点荷重の設定
        Dim i, id, j, k, kk As Integer
        For i = 1 To Nforce
            kk = KPforce(i)
            j = Ndim * (Kcomp(kk) - 1)
            For id = 1 To Ndim
                k = j + id
                Tf(k) = Force(i, id)
            Next id
        Next i

    End Sub

    Private Sub GausCalc()
        '積分点物性の計算
        Dim i, id, ie, ii, j, k As Integer

        For ie = 1 To Nelem
            j = 0
            For ii = 1 To 8
                i = NNelem(ie, ii)
                k = Ndim * (Kcomp(i) - 1)
                For id = 1 To Ndim
                    j = j + 1
                    k = k + 1
                    Eu(j) = Tfx(k)
                Next id
            Next ii
            If Ntype = 3 Then   '板の曲げ
                Call ElemMatrixPL(ie)    '要素ﾏﾄﾘｯｸｽの計算(板の曲げ)
            Else
                Call ElemMatrix2(ie)     '要素ﾏﾄﾘｯｸｽの計算2
            End If
        Next ie

    End Sub

    Private Sub GausInit(ByVal kg As Integer)
        'ｶﾞｳｽ点初期座標の計算
        'kg･･･ｶﾞｳｽ点番号
        Dim ii As Integer
        XGI(kg) = 0 : YGI(kg) = 0
        For ii = 1 To 8
            XGI(kg) = XGI(kg) + XEI(ii) * Shape(ii)
            YGI(kg) = YGI(kg) + YEI(ii) * Shape(ii)
        Next ii

    End Sub

    Private Sub HLoadSet()
        '分布荷重の節点荷重への換算
        Dim i, ic, ie, ig, ii, j, jb, jj, k, kk, mab As Integer
        Dim b1, b2, b3, b4, h As Double
        For ii = 1 To Nsurf
            i = KPsurf(ii, 1)
            j = KPsurf(ii, 2)
            k = KPsurf(ii, 3)
            For jj = 1 To 3
                jb = KPsurf(ii, jj)
                XE(jj) = X(jb)
                YE(jj) = Y(jb)
                If KindDPL > 0 Then
                    k = Ndim * (Kcomp(jb) - 1)
                    XE(jj) = XE(jj) + Tfx(k + 1)
                    YE(jj) = YE(jj) + Tfx(k + 2)
                End If
            Next jj
            If Ntype < 3 Then
                If Nmat = 1 Then
                    mab = 1
                Else
                    For ie = 1 To Nelem
                        ic = 0
                        For jj = 1 To 8
                            kk = NNelem(ie, jj)
                            If kk = i Or kk = j Or kk = k Then
                                ic = ic + 1
                            End If
                        Next jj
                        If ic = 3 Then
                            mab = NumMat(ie)
                            Exit For
                        End If
                    Next ie
                End If
                h = DataMat(mab, 3)
            End If

            For ig = 1 To Ngaus
                Call SideJacob(ig, b1, b2, b3) '  辺のＪＡＣＯＢ
                For i = 1 To 3
                    j = KPsurf(ii, i)
                    k = 2 * Kcomp(j)
                    j = k - 1
                    b4 = Shape(i) * b3
                    If Ntype < 3 Then
                        b4 = b4 * h
                    End If
                    Tf(j) = Tf(j) + (Ptang(ii) * b1 - Pnorm(ii) * b2) * b4
                    Tf(k) = Tf(k) + (Pnorm(ii) * b1 + Ptang(ii) * b2) * b4
                Next i
            Next ig
        Next ii
    End Sub

    Private Sub HLoadSetB()
        '分布荷重の節点荷重への換算（板の曲げ）
        Dim i, ib, ie, ig, ii, j, jg, k, kg As Integer
        Dim b1, da, dj, s, t As Double
        For ii = 1 To Nsurf
            ie = KPsurf(ii, 1)
            j = 0
            For i = 1 To 8
                ib = NNelem(ie, i)
                XE(i) = X(ib)
                YE(i) = Y(ib)
            Next i

            kg = 0
            For ig = 1 To Ngaus
                s = PosGaus(ig)
                For jg = 1 To Ngaus
                    t = PosGaus(jg)
                    kg = kg + 1
                    Call ShapeFunc(s, t)            '形状関数の計算
                    Call JacobElem(ie, kg, dj)      '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    da = dj * WeightG(ig) * WeightG(jg)
                    b1 = da * Pnorm(ii)
                    For i = 1 To 8
                        ib = NNelem(ie, i)
                        k = Ndim * (Kcomp(ib) - 1) + 1
                        Tf(k) = Tf(k) + b1 * Shape(i)
                    Next
                Next jg
            Next ig
        Next ii
    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim i, j, k, nsb As Integer
        Dim b1 As Single
        Select Case Ntype
            Case 3
                Nstress = 5 : Nvar = 24
            Case 4
                Nstress = 4 : Nvar = 16
            Case Else
                Nstress = 3 : Nvar = 16
        End Select
        If Ntype = 2 Then
            nsb = Nstress + 1
        Else
            nsb = Nstress
        End If

        Nall = Ndim * Npoint
        ReDim NPrefer(Nvar), Ek(Nvar, Nvar), B(Nstress, Nvar)
        ReDim D(Nstress, Nstress), Db(Nstress, Nvar)
        ReDim Nw(Npoint), Eu(Nvar), Sgaus(9, nsb), Spoint(8, nsb), Tp(Npoint, nsb)
        ReDim Eyb(Nelem, 9)
        ReDim Tf(Nall), Tfx(Nall)

        If KindDPL > 0 Then
            ReDim XEI(8), YEI(8), XGI(9), YGI(9)
        End If

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1) : WeightG(2) = 0.88888889

        'ﾔﾝｸﾞ率の初期設定
        For i = 1 To Nelem
            k = NumMat(i)
            b1 = DataMat(k, 1)
            For j = 1 To 9
                Eyb(i, j) = b1
            Next j
        Next i

    End Sub

    Private Sub InitialSet2(ByVal mb As Integer)
        '初期設定2
        Dim aa$
        Dim i, ib, ic, id, ie, ii, ip, j, j1, jb, k, k1, k2, nb, num, numall As Integer
        Dim nbuf(Npoint) As Integer

        '関連節点数の計算
        numall = 0
        nb = Ndim * (Ndim - 1) / 2
        For i = 1 To Npoint
            j1 = i - mb + 1
            If j1 < 0 Then
                j1 = 1
            End If
            For j = j1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To 8
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To 8
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            If Nspring > 0 Then
                For j = 1 To Nspring
                    k1 = KPspring(j, 1)
                    k2 = KPspring(j, 2)
                    If k1 = ip Then
                        If k2 > 0 Then
                            ib = Kcomp(k2)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    ElseIf k2 = ip Then
                        ib = Kcomp(k1)
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    End If
                Next j
            End If
            jb = 0
            For j = j1 To i
                If nbuf(j) > 0 Then
                    jb = j
                    Exit For
                End If
            Next j
            If jb = 0 Then
                aa$ = "対象列が見当たらないエラーが発生しました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            num = i - jb + 1
            numall = numall + num * Ndim * Ndim - nb
        Next i
        NumEff = numall

        ReDim Tk(NumEff)
        ReDim Idiag(Nall)

        '保存配列との関連付け
        numall = 0
        nb = 0
        For i = 1 To Npoint
            j1 = i - mb + 1
            If j1 < 0 Then
                j1 = 1
            End If
            For j = j1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To 8
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To 8
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            If Nspring > 0 Then
                For j = 1 To Nspring
                    k1 = KPspring(j, 1)
                    k2 = KPspring(j, 2)
                    If k1 = ip Then
                        If k2 > 0 Then
                            ib = Kcomp(k2)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    ElseIf k2 = ip Then
                        ib = Kcomp(k1)
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    End If
                Next j
            End If
            jb = 0
            For j = j1 To i
                If nbuf(j) > 0 Then
                    jb = j
                    Exit For
                End If
            Next j

            For id = 1 To Ndim
                nb = nb + 1
                For j = jb To i
                    If j = i Then
                        k2 = id
                    Else
                        k2 = Ndim
                    End If
                    For k = 1 To k2
                        numall = numall + 1
                    Next k
                Next j
                Idiag(nb) = numall
            Next id
        Next i

    End Sub

    Private Sub InitStrain()
        '初期応力の荷重換算
        Dim icount, ie, kb As Integer
        Dim h, rnu, ud As Double

        kb = 0
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie, -1, kb, h, rnu, ud) '要素ﾏﾄﾘｯｸｽの計算
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

    End Sub

    Private Sub JacobElem(ByVal ie As Integer, ByVal kg As Integer, _
        ByRef dj As Double)
        '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kg･･･ｶﾞｳｽ点番号
        'dj･･･ﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの行列式値
        Dim c1$, c2$
        Dim ii As Integer
        Dim b1, b2, b3, b4, b5, b6, b7, b8 As Double
        XG(kg) = 0 : YG(kg) = 0
        TempG(kg) = 0 : TempIG(kg) = 0
        b1 = 0 : b2 = 0 : b3 = 0 : b4 = 0
        For ii = 1 To 8
            XG(kg) = XG(kg) + XE(ii) * Shape(ii)
            YG(kg) = YG(kg) + YE(ii) * Shape(ii)
            TempG(kg) = TempG(kg) + TempE(ii) * Shape(ii)
            TempIG(kg) = TempIG(kg) + TempIE(ii) * Shape(ii)
            b1 = b1 + Ds(ii) * XE(ii)
            b2 = b2 + Ds(ii) * YE(ii)
            b3 = b3 + Dt(ii) * XE(ii)
            b4 = b4 + Dt(ii) * YE(ii)
        Next ii
        dj = b1 * b4 - b2 * b3
        If dj <= 0 Then
            c1$ = "計算実行エラー"
            c2$ = "要素" + LTrim$(Str$(ie)) + "（ガウス点" + LTrim$(Str$(kg))
            c2$ = c2$ + "）でヤコビアン面積が負か０になりました。"
            MsgBox(c2$, 0, c1$)
            End
        Else
            b5 = b4 / dj : b8 = b1 / dj
            b6 = -b2 / dj : b7 = -b3 / dj
            For ii = 1 To 8
                Dx(ii) = b5 * Ds(ii) + b6 * Dt(ii)
                Dy(ii) = b7 * Ds(ii) + b8 * Dt(ii)
            Next ii
        End If
    End Sub

    Private Sub KHSolver(ByRef k As Integer, ByVal kmax As Integer, _
    ByRef s0 As Single, ByRef sfm As Single, ByRef s As Single, _
    ByRef t As Single, ByVal xc As Single, ByVal yc As Single)
        'KH法による最適化ｿﾙﾊﾞｰ
        'k･･･繰返し数
        'kmax･･･最大繰返し数（計算打切り）
        's0･･･初期の関数値
        'sfm･･･最適化した最終関数値
        's,t･･･要素の局所座標
        'xc,yc･･･現在位置の座標
        Dim i, ichange, j, knew, nx As Integer
        Dim b1, b2, dx, sf, xb, xm As Single

        nx = 2              '変数の数
        Xvar(1) = s : Xvar(2) = t
        For i = 1 To nx
            Dratio(i) = 0.1
            EpsX(i) = 0.0001
        Next i

        Dim xmbuf(nx) As Single   '変数の前回中心値Ｘ
        Dim dxbuf(nx) As Single   '変数の前回変化ΔＸ

        k = 0
        Call CalFunc(s0, s, t, xc, yc) '初期の関数値計算
        sfm = s0

        Do
            knew = 0    '変数の中心値Ｘと変化ΔＸの更新有無
            k = k + 1   '繰返し回数加算
            For i = 1 To nx      '各変数毎の計算
                xb = Xvar(i)
                xm = xb
                dx = xb * Dratio(i)
                If Math.Abs(dx) < EpsX(i) Then  'dxが0になるのを防止
                    dx = EpsX(i)
                End If
                If k = 1 Or xm <> xmbuf(i) Or dx <> dxbuf(i) Then
                    knew = 1
                End If
                xmbuf(i) = xm
                dxbuf(i) = dx

                ichange = 0         '各変数での改善有無
                For j = 1 To 2      '変数値の±ΔＸで改善比較
                    If j = 1 Then
                        Xvar(i) = xb - dx
                    Else
                        Xvar(i) = xb + dx
                    End If
                    Call CalFunc(sf, Xvar(1), Xvar(2), xc, yc)    '関数値計算
                    If sf < sfm Then        '最小化
                        '                If sf > sfm Then       '最大化
                        ichange = 1
                        sfm = sf
                        xm = Xvar(i)
                    End If
                Next j
                Xvar(i) = xm
                If ichange > 0 Then     '改善有りの場合はΔＸ比率を増倍
                    Dratio(i) = CInc * Dratio(i)
                Else        '改善なしの場合はΔＸ比率を低減
                    b1 = Dratio(i)
                    Dratio(i) = CRed * b1
                    b2 = Math.Abs(Xvar(i) * Dratio(i))

                    'ΔＸは最小変化量以上とする
                    If b2 < EpsX(i) Then
                        Dratio(i) = b1
                    End If
                End If
            Next i
        Loop While k < kmax And knew = 1
        s = Xvar(1) : t = Xvar(2)

    End Sub

    Private Sub LoadSet()
        '荷重の設定
        If Nforce > 0 Then
            Call FLoadSet() '節点荷重の設定
        End If

        If NforceA > 0 Then
            Call FALoadSet() '座標位置荷重の設定
        End If

        If Nsurf > 0 Then
            If Ntype = 3 Then
                Call HLoadSetB() '分布荷重の節点荷重への換算（板の曲げ）
            Else
                Call HLoadSet() '分布荷重の節点荷重への換算
            End If
        End If

    End Sub

    Private Sub MiniSort2(ByVal kind As Integer, ByRef nsort() As Integer, _
    ByVal work() As Single, ByVal xbuf() As Single, ByVal ybuf() As Single)
        'ﾐﾆｿｰﾄ2
        '同じ変数値の場合に、第2座標値でソート
        'kind･･･主ｿｰﾄの座標軸番号（1:X軸、2:Y軸）
        'nsort()･･･元の変数番号のｿｰﾄ順番号
        'work()･･･ｿｰﾄ変数値
        'xbuf(),ybuf()･･･節点の座標
        Dim i, j, jb, jx, nb, n1, n2, nx As Integer
        Dim b1 As Single
        Dim nsort2(10) As Integer
        Dim work2(10) As Single

        i = 1
        Do
            If work(i) = work(i + 1) Then
                b1 = work(i)
                n1 = i
                For j = i + 1 To Npoint
                    If b1 = work(j) Then
                        n2 = j
                    Else
                        Exit For
                    End If
                Next j
                nx = n2 - n1 + 1
                ReDim nsort2(nx), work2(nx)
                jb = 0
                For j = n1 To n2
                    jb = jb + 1
                    nsort2(jb) = jb
                    nb = nsort(j)
                    If kind = 1 Then
                        work2(jb) = ybuf(nb)
                    Else
                        work2(jb) = xbuf(nb)
                    End If
                Next j
                Call ShellSortStd(nx, nsort2, work2)    'ｼｪｯﾙｿｰﾄ基本
                For j = 1 To nx
                    jb = n1 + nsort2(j) - 1
                    nsort2(j) = nsort(jb)
                Next j
                For j = 1 To nx
                    jx = n1 + j - 1
                    nsort(jx) = nsort2(j)
                Next j
                i = n2 + 1
            Else
                i = i + 1
            End If
        Loop While i < Npoint

    End Sub

    Private Sub PnumImproveNew(ByRef mb As Integer, ByVal mbx As Integer,
    ByVal xbuf() As Single, ByVal ybuf() As Single)
        '節点付番の改良
        'mb･･･改良後のﾊﾞﾝﾄﾞ幅
        'mbx･･･改良前のﾊﾞﾝﾄﾞ幅
        'xbuf(),ybuf()･･･節点の座標
        Dim i, ib, ie, k, kx, mbb As Integer
        Dim pa, qa, ratio As Single
        Dim kcbuf(Npoint) As Integer

        For ie = 1 To Nelem
            KdrawElem(ie) = 1
        Next ie
        ratio = 1.2
        i = 0
        Call AxisCheck(i, 1, Nelem, ratio, XaxisMin, pa, YaxisMin, qa, X, Y)
        'X、Y軸の最小・最大値と作画直角回転要否のﾁｪｯｸ

        For k = 1 To 2
            Call ShellSort2(k, kcbuf, xbuf, ybuf)    'ｼｪﾙｿｰﾄ2
            Call BandWidth2(mb, kcbuf)      'ﾊﾞﾝﾄﾞ幅の計算
            If k = 1 Then
                kx = 1
                mbb = mb
            ElseIf mb < mbb Then
                kx = k
                mbb = mb
            End If
        Next k

        If mbb < mbx Then
            Call ShellSort2(kx, kcbuf, xbuf, ybuf)    'ｼｪﾙｿｰﾄ2
            Call BandWidth2(mb, kcbuf)      'ﾊﾞﾝﾄﾞ幅の計算
            For i = 1 To Npoint
                Kcomp(i) = kcbuf(i)
            Next i
        Else
            mb = mbx
        End If

        For i = 1 To Npoint
            ib = Kcomp(i)
            KRcomp(ib) = i
        Next i

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用

        SwK.WriteLine("＜＜２Ｄ非線形弾性解析の計算結果＞＞")
        aa$ = "［FEM2Dデータファイル］" + "," + Fstruct$
        SwK.WriteLine(aa$)
        SwK.WriteLine(Title$)
        aa$ = "［材料データファイル］" + "," + Fmat$
        SwK.WriteLine(aa$)
        SwK.WriteLine(TitleM$)
        If KindHSt > 0 Then
            aa$ = "［熱応力条件データファイル］" + "," + Fhst$
            SwK.WriteLine(aa$)
            SwK.WriteLine(TitleH$)
        End If
        SwK.WriteLine("-----------------------------------------------")

    End Sub

    Private Sub ResFile2(ByVal mb As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$
        SwK.WriteLine("＊＊＊ 計算結果 ＊＊＊")
        aa$ = "バンド幅" + "," + Str(mb)
        SwK.WriteLine(aa$)
        aa$ = "保存配列のインデックス数" + "," + Str(NumEff)
        SwK.WriteLine(aa$)
        SwK.WriteLine("----------------------------------------------")
    End Sub

    Private Sub ResFile3(ByVal iconv As Integer, ByVal nk As Integer, _
    ByVal eps As Single)
        '結果ﾌｧｲﾙへの出力3
        'iconv･･･収束有無（0:非収束、1:収束）
        'nk･･･計算回数
        'eps･･･誤差率
        Dim a1$, aa$
        Dim i, id, ip As Integer
        Dim zbuf(3) As Single
        aa$ = ""

        a1$ = "最大の相当歪み"
        If KindDPL > 0 Then
            SwK.WriteLine("大変形計算を適用")
        End If
        If iconv = 0 Then
            aa$ = "非収束計算回数" + "," + Str(nk)
        Else
            aa$ = "収束計算回数" + "," + Str(nk)
        End If
        SwK.WriteLine(aa$)
        aa$ = "誤差率" + "," + Str(eps)
        SwK.WriteLine(aa$)
        aa$ = a1$ + "," + Str(EpsMax)
        SwK.WriteLine(aa$)
        SwK.WriteLine("----------------------------------------------")
        CalcRes$ = a1$ + Str(EpsMax) + Chr(13) + Chr(10)

        Select Case Ntype
            Case Is < 3
                aa$ = "＜節点番号、δX、δY＞"
            Case 3
                aa$ = "＜節点番号、δZ、θX、θY＞"
            Case 4
                aa$ = "＜節点番号、δR、δZ＞"
        End Select
        SwK.WriteLine("＊＊ 変位等の出力 ＊＊")
        SwK.WriteLine(aa$)
        For ip = 1 To Npoint
            i = Ndim * (Kcomp(ip) - 1)
            For id = 1 To Ndim
                zbuf(id) = Tf(i + id)
                If Math.Abs(zbuf(id)) > Math.Abs(DispMax(id)) Then
                    DispMax(id) = zbuf(id)
                    KDispMax(id) = ip
                End If
            Next id
            aa$ = Str(ip) + ",  " + Str$(zbuf(1)) + ",  " + Str$(zbuf(2))
            If Ntype = 3 Then
                aa$ = aa$ + ",  " + Str$(zbuf(3))
            End If
            SwK.WriteLine(aa$)
        Next ip

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim a1$, aa$, ad$
        Dim abuf$(9)
        Dim i, i1, i2, imax As Integer
        Dim z1, z2 As Single

        ad$ = "-------------------------------------------------------"
        aa$ = "注）σmax、σminは正負込みの最大、最小。その他は絶対値の最大。"
        a1$ = "変数項目、  最大値、        節点番号"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＜最大値データ＞")
        SwK.WriteLine(aa$)
        SwK.WriteLine(a1$)
        CalcRes$ = CalcRes$ + "＜最大値データ＞" + Cr$ + aa$
        CalcRes$ = CalcRes$ + Cr$ + a1$
        Select Case Ntype
            Case 3
                abuf$(1) = "δZ"
                abuf$(2) = "θX"
                abuf$(3) = "θY"
                imax = 3
            Case 4
                abuf$(1) = "δR"
                abuf$(2) = "δZ"
                imax = 2
            Case Else
                abuf$(1) = "δX"
                abuf$(2) = "δY"
                imax = 2
        End Select
        For i = 1 To imax
            aa$ = abuf$(i) + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(DispMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KDispMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        Next i
        Select Case Ntype
            Case 1
                abuf$(1) = "σx"
                abuf$(2) = "σy"
                abuf$(3) = "τxy"
                abuf$(4) = "σmax"
                abuf$(5) = "σmin"
                abuf$(6) = "τmax"
                abuf$(7) = "σmises"
                imax = 7
            Case 2
                abuf$(1) = "σx"
                abuf$(2) = "σy"
                abuf$(3) = "σz"
                abuf$(4) = "τxy"
                abuf$(5) = "σmax"
                abuf$(6) = "σmin"
                abuf$(7) = "τmax"
                abuf$(8) = "σmises"
                imax = 8
            Case 3
                abuf$(1) = "σx"
                abuf$(2) = "σy"
                abuf$(3) = "τxy"
                abuf$(4) = "τxz"
                abuf$(5) = "τyz"
                abuf$(6) = "σmax"
                abuf$(7) = "σmin"
                abuf$(8) = "τmax"
                abuf$(9) = "σmises"
                imax = 9
                z1 = -StMax(6)
                i1 = KStMax(6)
                z2 = -StMax(7)
                i2 = KStMax(7)
                If z2 > StMax(6) Then
                    StMax(6) = z2
                    KStMax(6) = i2
                End If
                If z1 < StMax(7) Then
                    StMax(7) = z1
                    KStMax(7) = i1
                End If
            Case 4
                abuf$(1) = "σr"
                abuf$(2) = "σz"
                abuf$(3) = "σθ"
                abuf$(4) = "τrz"
                abuf$(5) = "σmax"
                abuf$(6) = "σmin"
                abuf$(7) = "τmax"
                abuf$(8) = "σmises"
                imax = 8
        End Select
        For i = 1 To imax
            aa$ = abuf$(i) + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(StMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KStMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Chr(13) + Chr(10) + aa$
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
    ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'ub･･･拘束値
        Dim it, j, k1, ka, mx As Integer
        If k > 1 Then
            ka = k - mb + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it
                k1 = Idiag(k) - j
                If k1 > Idiag(k - 1) Then
                    If ub <> 0 Then
                        Tf(it) = Tf(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next it
        End If
        If k < Nall Then
            mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            For j = 2 To mx
                k1 = Idiag(k + j - 1) - j + 1
                If k1 > Idiag(k + j - 2) Then
                    If ub <> 0 Then
                        it = k + j - 1
                        Tf(it) = Tf(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next j
        End If
        Tk(Idiag(k)) = 1
        Tf(k) = ub

    End Sub

    Private Sub RestRTreat(ByVal mb As Integer)
        '軸対称体のR拘束処理
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim ip, j, k As Integer
        Dim eps, rmax, ub As Single
        Call RMaxCalc(rmax)     'R最大値の計算
        eps = 0.000001 * rmax
        ub = 0
        For ip = 1 To Npoint
            If Math.Abs(X(ip)) < eps Then
                j = Ndim * (Kcomp(ip) - 1)
                k = j + 1
                Call RestCond(k, mb, ub)    '拘束条件処理
            End If
        Next ip
    End Sub

    Private Sub RMaxCalc(ByRef rmax As Single)
        'R最大値の計算
        Dim i, ie, j As Integer
        Dim b1 As Single
        rmax = 0
        For ie = 1 To Nelem
            For j = 1 To 8
                i = NNelem(ie, j)
                b1 = Math.Abs(X(i))
                If b1 > rmax Then
                    rmax = b1
                End If
            Next j
        Next ie

    End Sub

    Private Sub ShapeFunc(ByVal s As Double, ByVal t As Double)
        '形状関数の計算
        's･･･要素のξ座標
        't･･･要素のη座標
        Dim b1, b2, b3, s2, ss, st, t2, tt As Double
        s2 = s * 2 : t2 = t * 2
        ss = s * s : tt = t * t : st = s * t
        b1 = ss * t : b2 = s * tt : b3 = st * 2
        Shape(1) = (-1 + st + ss + tt - b1 - b2) / 4
        Shape(2) = (1 - t - ss + b1) / 2
        Shape(3) = (-1 - st + ss + tt - b1 + b2) / 4
        Shape(4) = (1 + s - tt - b2) / 2
        Shape(5) = (-1 + st + ss + tt + b1 + b2) / 4
        Shape(6) = (1 + t - ss - b1) / 2
        Shape(7) = (-1 - st + ss + tt + b1 - b2) / 4
        Shape(8) = (1 - s - tt + b2) / 2
        Ds(1) = (t + s2 - b3 - tt) / 4
        Ds(2) = -s + st
        Ds(3) = (-t + s2 - b3 + tt) / 4
        Ds(4) = (1 - tt) / 2
        Ds(5) = (t + s2 + b3 + tt) / 4
        Ds(6) = -s - st
        Ds(7) = (-t + s2 + b3 - tt) / 4
        Ds(8) = (-1 + tt) / 2
        Dt(1) = (s + t2 - ss - b3) / 4
        Dt(2) = (-1 + ss) / 2
        Dt(3) = (-s + t2 - ss + b3) / 4
        Dt(4) = -t - st
        Dt(5) = (s + t2 + ss + b3) / 4
        Dt(6) = (1 - ss) / 2
        Dt(7) = (-s + t2 + ss - b3) / 4
        Dt(8) = -t + st
    End Sub

    Private Sub ShapeFuncS(ByVal s As Single, ByVal t As Single)
        '形状関数の計算
        's･･･要素のξ座標
        't･･･要素のη座標
        Dim b1, b2, b3, s2, ss, st, t2, tt As Single

        s2 = s * 2 : t2 = t * 2
        ss = s * s : tt = t * t : st = s * t
        b1 = ss * t : b2 = s * tt : b3 = st * 2
        Shape(1) = (-1 + st + ss + tt - b1 - b2) / 4
        Shape(2) = (1 - t - ss + b1) / 2
        Shape(3) = (-1 - st + ss + tt - b1 + b2) / 4
        Shape(4) = (1 + s - tt - b2) / 2
        Shape(5) = (-1 + st + ss + tt + b1 + b2) / 4
        Shape(6) = (1 + t - ss - b1) / 2
        Shape(7) = (-1 - st + ss + tt + b1 - b2) / 4
        Shape(8) = (1 - s - tt + b2) / 2
    End Sub

    Private Sub ShellSort2(ByVal kind As Integer, ByRef kcbuf() As Integer, _
ByVal xbuf() As Single, ByVal ybuf() As Single)
        'ｼｪﾙｿｰﾄ
        'kind･･･主ｿｰﾄの座標軸番号（1:X軸、2:Y軸）
        'kcbuf()･･･元の節点の変数順序
        'xbuf(),ybuf()･･･節点の座標
        Dim i As Integer
        Dim nsort(Npoint) As Integer
        Dim work(Npoint) As Single

        Select Case kind
            Case 1
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = xbuf(i)
                Next i
            Case 2
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = ybuf(i)
                Next i
        End Select

        Call ShellSortStd(Npoint, nsort, work)    'ｼｪｯﾙｿｰﾄ基本

        Call MiniSort2(kind, nsort, work, xbuf, ybuf)    'ﾐﾆｿｰﾄ

        For i = 1 To Npoint
            kcbuf(nsort(i)) = i
        Next i

    End Sub

    Private Sub ShellSortStd(ByVal nx As Integer, ByRef nsort() As Integer, ByRef work() As Single)
        'ｼｪﾙｿｰﾄ基本
        'nx･･･変数の数
        'nsort()･･ｿｰﾄ順の元変数の番号
        'work()･･･ｿｰﾄ順の変数値
        Dim i, ib, j, m As Integer
        Dim varb As Single

        m = nx
        Do While m > 1
            m = m \ 2
            For j = m + 1 To nx
                varb = work(j)
                ib = nsort(j)
                i = j - m
                Do While work(i) >= varb
                    work(i + m) = work(i)
                    nsort(i + m) = nsort(i)
                    i = i - m
                    If i <= 0 Then
                        Exit Do
                    End If
                Loop
                work(i + m) = varb
                nsort(i + m) = ib
            Next j
        Loop

    End Sub

    Private Sub SideJacob(ByVal ig As Integer, ByRef b1 As Double, _
        ByRef b2 As Double, ByRef b3 As Double)
        '辺のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽ成分の計算
        'ig･･･ｶﾞｳｽ点番号
        'b1･･･X座標のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽ
        'b2･･･Y座標のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽ
        'b3･･･積分係数
        Dim i As Integer
        Dim s, s2, ss, xb As Double

        s = PosGaus(ig)
        s2 = s * 2 : ss = s * s
        Shape(1) = (-s + ss) / 2
        Shape(2) = 1 - ss
        Shape(3) = (s + ss) / 2
        Ds(1) = (-1 + s2) / 2
        Ds(2) = -s2
        Ds(3) = (1 + s2) / 2
        xb = 0 : b1 = 0 : b2 = 0
        For i = 1 To 3
            xb = xb + XE(i) * Shape(i)
            b1 = b1 + Ds(i) * XE(i)
            b2 = b2 + Ds(i) * YE(i)
        Next i
        '    dj = Math.Sqrt(b1 ^ 2 + b2 ^ 2)
        If Ntype < 3 Then
            b3 = WeightG(ig)
        Else
            b3 = Dpai * xb * WeightG(ig)
        End If

    End Sub

    Private Sub SlopeReset()
        '傾斜拘束の戻し
        Dim i, ib, k As Integer
        Dim b1, b2, b3, b4, cosb, sinb As Double

        b1 = Pai / 180
        For i = 1 To Nslope
            ib = Nsrest(i)
            k = Ndim * (Kcomp(ib) - 1) + 1
            b2 = SAngle(i) * b1
            cosb = Math.Cos(b2)
            sinb = Math.Sin(b2)
            b3 = Tf(k)
            b4 = Tf(k + 1)
            Tf(k) = cosb * b3 - sinb * b4
            Tf(k + 1) = cosb * b4 + sinb * b3
        Next i

    End Sub

    Private Sub SlopeSet(ByVal mh As Integer)
        '傾斜拘束の処理
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, i1, i2, ib, ii, j, k, k1, k2 As Integer
        Dim b1, b2, b3, b4, b5, cos2b, cosb, scb, sinb, sin2b, ub As Double

        b1 = Pai / 180
        For i = 1 To Nslope
            ib = Nsrest(i)
            k = Ndim * (Kcomp(ib) - 1) + 1
            b2 = SAngle(i) * b1
            cosb = Math.Cos(b2)
            sinb = Math.Sin(b2)
            i1 = k - mh + 2
            If i1 < 1 Then
                i1 = 1
            End If
            i2 = k + mh - 1
            If i2 > Nall Then
                i2 = Nall
            End If

            '行列の変換Ｔ’ＫＴ
            For ii = i1 To k - 1
                j = k - ii
                k1 = Idiag(k) - j
                k2 = Idiag(k + 1) - j - 1
                If k1 > Idiag(k - 1) Then
                    b3 = Tk(k1)
                    b4 = Tk(k2)
                    Tk(k1) = cosb * b3 + sinb * b4
                    Tk(k2) = cosb * b4 - sinb * b3
                End If
            Next ii
            For ii = k + 2 To i2
                j = ii - k
                k1 = Idiag(ii) - j
                If k1 > Idiag(ii - 1) Then
                    k2 = k1 + 1
                    b3 = Tk(k1)
                    b4 = Tk(k2)
                    Tk(k1) = cosb * b3 + sinb * b4
                    Tk(k2) = cosb * b4 - sinb * b3
                End If
            Next ii
            k1 = Idiag(k)
            k2 = Idiag(k + 1)
            b3 = Tk(k1)
            b4 = Tk(k2 - 1)
            b5 = Tk(k2)
            cos2b = cosb * cosb
            scb = sinb * cosb
            sin2b = sinb * sinb
            Tk(k1) = b3 * cos2b + 2 * b4 * scb + b5 * sin2b
            Tk(k2 - 1) = b4 * (cos2b - sin2b) + (b5 - b3) * scb
            Tk(k2) = b3 * sin2b - 2 * b4 * scb + b5 * cos2b

            '右辺の変換Ｔ’Ｆ
            b3 = Tf(k)
            b4 = Tf(k + 1)
            Tf(k) = cosb * b3 + sinb * b4
            Tf(k + 1) = cosb * b4 - sinb * b3
        Next i
        ub = 0
        For i = 1 To Nslope
            ib = Nsrest(i)
            k = Ndim * (Kcomp(ib) - 1) + 2
            Call RestCond(k, mh, ub)    '拘束条件処理
        Next i

    End Sub

    Private Sub Solver1()
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL'分解）
        Dim aa$, timn$
        Dim i, ib, icount, ii, ij, ik, j, j1, jb, jj, jk, k, k1, kdiv, kk, ks As Integer
        Dim crate, dn, fwx, riter, rmesh As Single
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 0
        rmesh = 0.8
        dn = Nall / 10.0 - 0.001
        riter = dn
        kdiv = 0
        Dim time1 As Date = Now
        For i = 2 To Nall
            ib = Idiag(i) - i
            j1 = Idiag(i - 1) - ib + 1
            For j = j1 To i
                sum = 0
                jb = Idiag(j) - j
                ks = Idiag(j - 1) - jb + 1
                If ks > j1 Then
                    k1 = ks
                Else
                    k1 = j1
                End If
                ij = ib + j
                If k1 <= j - 1 Then
                    For k = k1 To j - 1
                        ik = ib + k
                        kk = Idiag(k)
                        jk = jb + k
                        sum = sum + Tk(ik) * Tk(kk) * Tk(jk)
                    Next k
                End If
                If j = i Then
                    ii = Idiag(i)
                    Tk(ii) = Tk(ii) - sum
                Else
                    jj = Idiag(j)
                    Tk(ij) = (Tk(ij) - sum) / Tk(jj)
                End If
            Next j
            If KindDPL = 0 Then
                riter = riter - 1
                If riter <= 0 Then
                    rmesh = rmesh - 0.06
                    crate = 1 - rmesh
                    fwx = rmesh * Fw1 + crate * Fw2
                    ProgressBar1.Value = 100 * fwx / Fw2
                    kdiv = kdiv + 1
                    riter = dn
                End If
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next i

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mh As Integer)
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, ib, j, j1, j2, j3, k, kk As Integer
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        For i = 2 To Nall
            sum = 0
            ib = Idiag(i) - i
            j1 = Idiag(i - 1) - ib + 1
            If j1 < i Then
                For j = j1 To i - 1
                    kk = ib + j
                    sum = sum + Tk(kk) * Tf(j)
                Next j
            End If
            Tf(i) = Tf(i) - sum
        Next i
        For i = 1 To Nall
            k = Idiag(i)
            If Tk(k) = 0 Then
                aa$ = "ｿﾙﾊﾞｰ2でﾋﾟﾎﾞｯﾄが0になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            Tf(i) = Tf(i) / Tk(k)
        Next i

        For i = Nall - 1 To 1 Step -1
            j1 = i + 1
            j2 = j1 + mh - 1
            If j2 > Nall Then
                j2 = Nall
            End If
            sum = 0
            For j = j1 To j2
                j3 = Idiag(j - 1) - Idiag(j) + j + 1
                If j3 <= i Then
                    kk = Idiag(j) - j + i
                    sum = sum + Tk(kk) * Tf(j)
                End If
            Next j
            Tf(i) = Tf(i) - sum
        Next i

        gr.Dispose()

    End Sub

    Private Sub SpringSet()
        'バネ支持の設定
        Dim ib, j, jj, k, k1, k2, kb, kk, m As Integer
        Dim b1 As Single
        Dim acos(2), aval1(2), aval2(2), csb(2), fsb(2) As Single
        For ib = 1 To Nspring
            If KPspring(ib, 2) = 0 Then '単独ﾊﾞﾈ
                k = Ndim * (Kcomp(KPspring(ib, 1)) - 1)
                For j = 1 To Ndim
                    k = k + 1
                    kk = Idiag(k)
                    Tk(kk) = Tk(kk) - Cspring(ib, j)
                    Tf(k) = Tf(k) + Fspring(ib, j)
                Next j
            ElseIf Ntype <> 3 Then  '節点間ﾊﾞﾈ
                k1 = KPspring(ib, 1)
                k2 = KPspring(ib, 2)
                aval1(1) = X(k1)
                aval1(2) = Y(k1)
                aval2(1) = X(k2)
                aval2(2) = Y(k2)
                Call CosCalc2(aval1, aval2, acos) '2点間の方向余弦の計算
                For j = 1 To 2
                    csb(j) = Cspring(ib, 1) * acos(j)
                    fsb(j) = Fspring(ib, 1) * acos(j)
                Next j
                k1 = Ndim * (Kcomp(k1) - 1)
                k2 = Ndim * (Kcomp(k2) - 1)
                For m = 1 To 2  '節点1と2
                    If m = 1 Then
                        k = k1
                        b1 = 1  '右辺への初期ﾊﾞﾈ力の加算符号
                    Else
                        k = k2
                        b1 = -1
                    End If
                    For j = 1 To 2  'XとY方向
                        k = k + 1
                        kk = Idiag(k)
                        Tk(kk) = Tk(kk) - csb(j) * acos(j)
                        Tf(k) = Tf(k) + b1 * fsb(j)
                        If j = 1 Then   'X変位の場合はY変位への剛性加算
                            kk = Idiag(k + 1) - 1
                            Tk(kk) = Tk(kk) - csb(1) * acos(2)
                        End If
                        If m = 1 And k1 < k2 Then   '大きい変数番号の側で記憶
                            For jj = 1 To 2
                                kb = k2 + jj
                                kk = Idiag(kb) - kb + k
                                Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                            Next jj
                        ElseIf m = 2 And k2 < k1 Then
                            For jj = 1 To 2
                                kb = k1 + jj
                                kk = Idiag(kb) - kb + k
                                Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                            Next jj
                        End If
                    Next j
                Next m
            End If
        Next ib

    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, ib, it, j, jt, k As Integer
        For i = 1 To Nvar
            For j = i To Nvar
                it = NPrefer(i) : jt = NPrefer(j)
                If it > jt Then
                    ib = it
                    it = jt
                    jt = ib
                End If
                k = Idiag(jt) - jt + it
                Tk(k) = Tk(k) + Ek(i, j)
            Next j
        Next i
    End Sub

    Private Sub StressCalc()
        '応力計算
        Dim aa$
        Dim i, icount, id, ie, ii, imat, init, ip, isb, istage, j, k, kb, kg, nsb As Integer
        Dim b1, h, rnu As Double
        Dim sth, sx, sy, txy, txz, tyz, ud As Double

        aa$ = ""
        If Ntype = 2 Then
            nsb = Nstress + 1
        Else
            nsb = Nstress
        End If

        kg = 9  'ｶﾞｳｽ点総数
        istage = 1 : init = 0
        For imat = 1 To Nmat
            kb = 0
            If Nmat > 1 Then
                SwK.WriteLine("----------------------------------------------")
                aa$ = "材料番号" + "," + Str(imat)
                SwK.WriteLine(aa$)
            End If
            For ip = 1 To Npoint
                Nw(ip) = 0
                For isb = 1 To nsb
                    Tp(ip, isb) = 0
                Next isb
            Next ip
            icount = 0
            For ie = 1 To Nelem
                If NumMat(ie) = imat Then
                    j = 0
                    For ii = 1 To 8
                        i = NNelem(ie, ii)
                        k = Ndim * (Kcomp(i) - 1)
                        For id = 1 To Ndim
                            j = j + 1
                            k = k + 1
                            Eu(j) = Tf(k)
                        Next id
                    Next ii
                    Call ElemMatrix(ie, istage, kb, h, rnu, ud)      '要素ﾏﾄﾘｯｸｽの計算
                    For i = 1 To 8
                        For isb = 1 To nsb
                            Spoint(i, isb) = 0
                        Next isb
                        For j = 1 To kg
                            b1 = Tr(i, j)
                            For isb = 1 To nsb
                                Spoint(i, isb) = Spoint(i, isb) + b1 * Sgaus(j, isb)
                            Next isb
                        Next j
                    Next i
                    j = 0
                    For ii = 1 To 8
                        i = Kcomp(NNelem(ie, ii))
                        j = j + 1
                        Nw(i) = Nw(i) + 1
                        For isb = 1 To nsb
                            Tp(i, isb) = Tp(i, isb) + Spoint(j, isb)
                        Next isb
                    Next ii
                End If
                If icount < 99 Then
                    icount = icount + 1
                Else
                    Application.DoEvents()
                    icount = 0
                End If
            Next ie
            Select Case Ntype
                Case 1
                    aa$ = "＜節点番号、σx、σy、τxy、σmax、σmin、τmax、"
                    aa$ = aa$ + "σmises、θps＞"
                Case 2
                    aa$ = "＜節点番号、σx、σy、σz、τxy、σmax、σmin、"
                    aa$ = aa$ + "τmax、σmises、θps＞"
                Case 3
                    aa$ = "＜節点番号、σx、σy、τxy、τxz、τyz、σmax、σmax(裏)、"
                    aa$ = aa$ + "σmin、σmin(裏)、τmax、σmises、θps＞"
                Case 4
                    aa$ = "＜節点番号、σr、σz、σθ、τrz、σmax、σmin、"
                    aa$ = aa$ + "τmax、σmises、θps＞"
            End Select
            SwK.WriteLine("-----------------------------------------------")
            SwK.WriteLine("＊＊ 節点応力の出力 ＊＊")
            SwK.WriteLine(aa$)
            Application.DoEvents()
            icount = 0
            For ii = 1 To Npoint
                ip = Kcomp(ii)
                If Nw(ip) > 0 Then
                    i = Nw(ip)
                    sx = Tp(ip, 1) / i
                    sy = Tp(ip, 2) / i
                    Select Case Ntype
                        Case Is < 3
                            txy = Tp(ip, 3) / i
                        Case 3
                            txy = Tp(ip, 3) / i
                            txz = Tp(ip, 4) / i : tyz = Tp(ip, 5) / i
                        Case 4
                            sth = Tp(ip, 3) / i : txy = Tp(ip, 4) / i
                    End Select
                    If Ntype = 2 Then
                        sth = Tp(ip, 4) / i
                    End If
                    Call StressOut2(ii, sth, sx, sy, txy, txz, tyz)  '応力値の出力
                End If
                If icount < 999 Then
                    icount = icount + 1
                Else
                    Application.DoEvents()
                    icount = 0
                End If
            Next ii
        Next imat

    End Sub

    Private Sub StressOut2(ByVal ip As Integer, ByVal sth As Double,
        ByVal sx As Double, ByVal sy As Double, ByVal txy As Double,
        ByVal txz As Double, ByVal tyz As Double)
        '応力値の出力
        'sth･･･σθまたはσz
        'sx･･･σx
        'sy･･･σy
        'txy･･･τxy
        'txz･･･τxz
        'tyz･･･τyz
        Dim aa$
        Dim k, nsb As Integer
        Dim z1, z2, z3, zb, ztheta As Single
        Dim b1, b2 As Double
        Dim zbuf(10) As Single

        If Ntype = 2 Then
            nsb = Nstress + 1
        Else
            nsb = Nstress
        End If

        zbuf(1) = sx
        zbuf(2) = sy
        Select Case Ntype
            Case 1
                zbuf(3) = txy
            Case 2
                zbuf(3) = sth
                zbuf(4) = txy
            Case 3
                zbuf(3) = txy
                zbuf(4) = txz
                zbuf(5) = tyz
            Case 4
                zbuf(3) = sth
                zbuf(4) = txy
        End Select

        ztheta = 45
        If sx <> sy Then
            ztheta = 57.2958 * 0.5 * Math.Atan(2 * txy / (sx - sy))
        End If
        If txy < 0 Then
            If ztheta > 0 Then
                ztheta = ztheta - 90
            End If
        ElseIf ztheta < 0 Then
            ztheta = ztheta + 90
        End If
        b1 = (sx + sy) / 2
        b2 = Math.Sqrt((sx - sy) ^ 2 / 4 + txy * txy)
        z1 = b1 + b2
        z2 = b1 - b2
        z3 = b2
        If Ntype = 4 Then
            zb = sth
            If zb > z1 Then
                z1 = zb
            ElseIf zb < z2 Then
                z2 = zb
            End If
        End If
        If Ntype = 3 Then
            For k = 1 To 2
                If k = 1 Then
                    zb = Math.Abs(txz)
                Else
                    zb = Math.Abs(tyz)
                End If
                If zb > z3 Then
                    z3 = zb
                End If
            Next k
        End If
        zbuf(nsb + 1) = z1
        zbuf(nsb + 2) = z2
        zbuf(nsb + 3) = z3

        'Mises応力の計算
        Select Case Ntype
            Case 1
                b1 = sx ^ 2 + sy ^ 2 - sx * sy + 3 * txy ^ 2
            Case 3
                b1 = sx ^ 2 + sy ^ 2 - sx * sy + 3 * (txy ^ 2 + txz ^ 2 + tyz ^ 2)
            Case Else
                b1 = 0.5 * ((sx - sy) ^ 2 + (sx - sth) ^ 2 + (sy - sth) ^ 2) + 3 * txy ^ 2
        End Select
        zbuf(nsb + 4) = Math.Sqrt(b1)
        zbuf(nsb + 5) = ztheta

        aa$ = Str(ip)
        If Ntype = 3 Then
            z1 = -zbuf(6)
            z2 = -zbuf(7)
            For k = 1 To nsb + 5
                aa$ = aa$ + ",  " + Str(zbuf(k))
                If k = 6 Then
                    aa$ = aa$ + ",  " + Str(z2)
                ElseIf k = 7 Then
                    aa$ = aa$ + ",  " + Str(z1)
                End If
            Next k
        Else
            For k = 1 To nsb + 5
                aa$ = aa$ + ",  " + Str(zbuf(k))
            Next k
        End If
        SwK.WriteLine(aa$)

        If ip = 1 Then
            For k = 1 To nsb + 4
                StMax(k) = zbuf(k)
                KStMax(k) = ip
            Next k
        Else
            For k = 1 To nsb + 4
                If k = nsb + 1 Then
                    If zbuf(k) > StMax(k) Then
                        StMax(k) = zbuf(k)
                        KStMax(k) = ip
                    End If
                ElseIf k = nsb + 2 Then
                    If zbuf(k) < StMax(k) Then
                        StMax(k) = zbuf(k)
                        KStMax(k) = ip
                    End If
                Else
                    If Math.Abs(zbuf(k)) > Math.Abs(StMax(k)) Then
                        StMax(k) = zbuf(k)
                        KStMax(k) = ip
                    End If
                End If
            Next k
        End If

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub FEM2Cal3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, ib, icc, iconv, icount, id, ie, ii, ik, istage As Integer
        Dim j, k, kb, mb, mbx, nk As Integer
        Dim b1, drmesh, fwx, rmesh, sec As Single
        Dim df, eps, fmax, h, rnu, ub, ud As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        Me.Show()

        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        Fw1 = 0 : Fw2 = 100

        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Dim xbuf(Npoint), ybuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf)   '座標値の端数処理
        ReDim Kcomp(Npoint), KRcomp(Npoint)
        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算
        Call PnumImproveNew(mb, mbx, xbuf, ybuf)  '節点順序の改良
        Application.DoEvents()

        Call InitialSet1()  '初期設定
        Call TrSet()    'Tr配列の設定

        Call InitialSet2(mb)  '初期設定2

        Call ResFile2(mb)   '結果ﾌｧｲﾙへの出力2

        icc = 0
        If Ntype <> 3 And Nslope > 0 Then
            icc = 1     '傾斜拘束有り
        End If

        rmesh = 0
        drmesh = 0.8 / NKmax
        For ik = 1 To NKmax
            If KindHSt > 0 Then
                Call InitStrain()   '初期応力の計算
            End If

            Call LoadSet()  '荷重の設定

            aa$ = "要素計算中" + "   "
            Call TimCal(1, timn$)
            aa$ = aa$ + timn$
            gr.Clear(Color.White)
            gr.DrawString(aa$, fnt, myBrush, 1, 1)

            Application.DoEvents()
            icount = 0
            istage = 0 : kb = 0
            For ie = 1 To Nelem
                Call ElemMatrix(ie, istage, kb, h, rnu, ud)      '要素ﾏﾄﾘｯｸｽの
                Call Store()                                     '全体ﾏﾄﾘｯｸｽへの蓄積
                If icount < 99 Then
                    icount = icount + 1
                Else
                    Application.DoEvents()
                    icount = 0
                End If
            Next ie

            If Nspring > 0 Then
                Call SpringSet()    'バネ支持の設定
            End If

            If icc > 0 Then
                Call SlopeSet(mb)   '傾斜拘束の処理
            End If

            '進行表示
            rmesh = rmesh + 0.2 * drmesh
            fwx = (1 - rmesh) * Fw1 + rmesh * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2

            For ib = 1 To Nbound
                ii = Nrest(ib)
                j = Ndim * (Kcomp(ii) - 1)
                For id = 1 To Ndim
                    If Jdirect(ib, id) > 0 Then
                        ub = Vdirect(ib, id)
                        k = j + id
                        Call RestCond(k, mb, ub)    '拘束条件処理
                    End If
                Next id
            Next ib

            If Ntype = 4 Then
                Call RestRTreat(mb)     '軸対称体のR拘束処理
            End If

            Call Solver1()  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）

            Call Solver2(mb)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

            Application.DoEvents()
            If icc > 0 Then
                Call SlopeReset()   '傾斜拘束の戻し
            End If

            '進行表示
            rmesh = rmesh + 0.8 * drmesh
            fwx = (1 - rmesh) * Fw1 + rmesh * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2
            Dim timenew1 As Date = Now
            sec = TimeLap(Timst, timenew1)
            b1 = 1 - rmesh
            Call ReqTime(rmesh, b1, sec)   '残りの所要時間の計算

            If NKmax > 1 Then
                df = 0 : fmax = 0
                For j = 1 To Nall
                    ub = Math.Abs(Tf(j) - Tfx(j))
                    If ub > df Then
                        df = ub
                    End If
                    ub = Math.Abs(Tfx(j))
                    If ub > fmax Then
                        fmax = ub
                    End If
                    Tfx(j) = Tf(j)
                Next j
                If ik > 1 Then
                    eps = df / fmax
                    If eps < EpsCalc Then
                        iconv = 1
                        nk = ik
                        Exit For
                    End If
                End If
                If ik = NKmax Then
                    nk = ik
                    Exit For
                Else
                    For ii = 1 To Nall
                        Tf(ii) = 0
                    Next ii
                    For ii = 1 To NumEff
                        Tk(ii) = 0
                    Next ii
                End If
            Else
                iconv = 1
                Exit For
            End If
            Call GausCalc()     '積分点物性の計算
        Next ik

        Me.BringToFront()
        If iconv = 0 Then
            SwK.Close()
            aa$ = "計算が収束しませんでした！"
            aa$ = aa$ + Cr$ + "繰返し計算回数" + Str$(nk)
            MsgBox(aa$, 0, "計算エラー")
        Else
            Call ResFile3(iconv, nk, eps)   '結果ﾌｧｲﾙへの出力3

            Call StressCalc()   '応力計算
            Application.DoEvents()

            Call BForceCalc()   '拘束節点の反力計算
            Application.DoEvents()

            Call ResFile4()     '結果ﾌｧｲﾙへの出力4

            '進行表示
            ProgressBar1.Value = 100

            Call TimCal(1, timn$)
            aa$ = "END   " & timn$
            SwK.WriteLine(aa$)
            SwK.Close()

            Label1.Text = "計算終了！"
            Label2.Text = "計算結果をファイルへ出力しました。"
            Label3.Text = aa$
            aa$ = "計算が終了しました。"
            aa$ = aa$ + Chr(13) + Chr(10) + "繰返し計算回数" + Str$(nk)
            aa$ = aa$ + Chr(13) + Chr(10) + CalcRes$
            MsgBox(aa$, 0, "計算確認")
        End If

        gr.Dispose()

        Me.Close()

    End Sub
End Class
