'入力ﾃﾞｰﾀﾌｧｲﾙの読み込みﾌﾟﾛｸﾞﾗﾑ
Imports System.IO

Public Class Hst2Dat6
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents OpenFileDialog1 As System.Windows.Forms.OpenFileDialog
    Friend WithEvents SaveFileDialog1 As System.Windows.Forms.SaveFileDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog()
        Me.SaveFileDialog1 = New System.Windows.Forms.SaveFileDialog()
        '
        'OpenFileDialog1
        '
        '
        'SaveFileDialog1
        '
        Me.SaveFileDialog1.FileName = "doc1"
        '
        'Hst2Dat6
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Name = "Hst2Dat6"
        Me.Text = "HSt2Dat6"

    End Sub

#End Region

    Private Sub DfileIn()
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み実行
        Dim aa$, fxb$
        Dim kh As Integer

        fxb$ = ""
        If KdataBackup > 0 Then
            Call FileName(Fhst$, fxb$)
            'ﾌｧｲﾙ名Fm$の拡張子なしの部分fxb$を取得
            fxb$ = fxb$ + ".bak"
            If File.Exists(fxb$) Then
                File.Delete(fxb$)
            End If
            File.Copy(Fhst$, fxb$)
        End If

        kh = 0
        Try
            Call HFileInputU(Fhst$, 0) '熱応力条件ﾃﾞｰﾀﾌｧｲﾙの一部読み込み
            KdataChangeH = 0
        Catch ex As Exception
            kh = -1
        End Try
        If kh < 0 Then
            KfileOK = 0
            aa$ = "熱応力条件データファイルを読み込めません！"
            MsgBox(aa$, 0, "ファイルエラー")
            Me.Close()
        End If

        If File.Exists(Fstruct$) Then
            kh = 0
            Try
                Call FEM2FileU(Fstruct$)    'FEM2D構造ﾌｧｲﾙの読み込み
            Catch ex As Exception
                kh = -1
            End Try
            If kh < 0 Then
                KfileOK = 0
                aa$ = "FEM2D構造ファイルを読み込めません！"
                MsgBox(aa$, 0, "ファイルエラー")
                Me.Close()
            End If

            kh = 0
            Try
                Call HFileInputU(Fhst$, 1) '熱応力条件ﾃﾞｰﾀﾌｧｲﾙの全部読み込み
            Catch ex As Exception
                kh = -1
            End Try
            If kh < 0 Then
                KfileOK = 0
                aa$ = "熱応力条件データファイルを読み込めません！"
                MsgBox(aa$, 0, "ファイルエラー")
                Me.Close()
            End If

            If Ntype = 3 Then
                aa$ = "熱応力解析は板の曲げに対応していません！"
                MsgBox(aa$, 0, "ファイルエラー")
                Me.Close()
            End If
        Else
            KfileOK = 0
            aa$ = "構造ファイルが見つかりません！"
            MsgBox(aa$, 0, "データエラー")
            Me.Close()
        End If

    End Sub

    Private Sub OpenFileDialog1_FileOk(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
        KfileOK = 1

    End Sub

    Private Sub SaveFileDialog1_FileOk(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles SaveFileDialog1.FileOk
        KfileOK = 1

    End Sub

    Private Sub HSt2Dat6_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim fxb$
        fxb$ = ""
        If InOut > 0 Then
            Call FileName(Fstruct$, fxb$)
            'ﾌｧｲﾙ名Fstruct$の拡張子なしの部分fxb$を取得
            Fhst$ = fxb$ + "H.dat"
        ElseIf Fhst$ = "" Then
            Call TmpFileIn() 'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        End If

        KfileOK = 0
        If InOut = 0 Then
            OpenFileDialog1.Filter = "すべてのファイル(*.*)|*.*|データファイル(*.dat)|*.dat"
            OpenFileDialog1.FilterIndex = 2
            OpenFileDialog1.FileName = Fhst$
            OpenFileDialog1.ShowDialog()
            If KfileOK > 0 Then
                Fhst$ = OpenFileDialog1.FileName
                Try
                    Dim sr As New IO.StreamReader(Fhst$)
                    sr.Close()
                Catch
                    KfileOK = 0
                    MsgBox("指定されたデータファイルが開けません！", 0, "オープンエラー")
                    Me.Close()
                End Try
            End If
        Else
            SaveFileDialog1.Filter = "すべてのファイル(*.*)|*.*|データファイル(*.dat)|*.dat"
            SaveFileDialog1.FilterIndex = 2
            SaveFileDialog1.FileName = Fhst$
            SaveFileDialog1.CreatePrompt = True     '書込可能性ﾁｪｯｸ
            SaveFileDialog1.OverwritePrompt = True  '上書注意表示
            SaveFileDialog1.ShowDialog()
            If KfileOK > 0 Then
                Fhst$ = SaveFileDialog1.FileName
            End If
        End If

        If KfileOK > 0 Then
            If InOut = 0 Then
                Call DfileIn()  '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み実行
            Else
                Call HFileOutU(Fhst$)    '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
                KdataChangeH = 0
            End If
            If Fhst$ <> UFileH(1) Then
                UFileH(0) = Fhst$
                UFileAddH()     'UFileHの追加処理
                KnewUFileH = 1
            End If
            Fy$ = ""
            Call TmpFileOut() 'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        End If

        Me.Close()

    End Sub
End Class
